# Getting Started

Welcome to Asynchronous Programming in Rust! If you're looking to start writing
asynchronous Rust code, you've come to the right place. Whether you're building
a web server, a database, or an operating system, this book will show you
how to use Rust's asynchronous programming tools to get the most out of your
hardware.

## What This Book Covers

This book aims to be a comprehensive, up-to-date guide to using Rust's async
language features and libraries, appropriate for beginners and old hands alike.

- The early chapters provide an introduction to async programming in general,
and to Rust's particular take on it.

- The middle chapters discuss key utilities and control-flow tools you can use
when writing async code, and describe best-practices for structuring libraries
and applications to maximize performance and reusability.

- The last section of the book covers the broader async ecosystem, and provides
a number of examples of how to accomplish common tasks.

With that out of the way, let's explore the exciting world of Asynchronous
Programming in Rust!
